<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.20"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SemanticSearchImplementation: SemanticSearchImplementation.ElasticsearchSearchClient Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SemanticSearchImplementation
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.20 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespace_semantic_search_implementation.html">SemanticSearchImplementation</a></li><li class="navelem"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html">ElasticsearchSearchClient</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="#pri-static-attribs">Static Private Attributes</a> &#124;
<a href="class_semantic_search_implementation_1_1_elasticsearch_search_client-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">SemanticSearchImplementation.ElasticsearchSearchClient Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Implements necessary functions to use Elasticsearch as a search engine.  
 <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#details">More...</a></p>
<div class="dynheader">
Inheritance diagram for SemanticSearchImplementation.ElasticsearchSearchClient:</div>
<div class="dyncontent">
 <div class="center">
  <img src="class_semantic_search_implementation_1_1_elasticsearch_search_client.png" usemap="#SemanticSearchImplementation.ElasticsearchSearchClient_map" alt=""/>
  <map id="SemanticSearchImplementation.ElasticsearchSearchClient_map" name="SemanticSearchImplementation.ElasticsearchSearchClient_map">
<area href="interface_semantic_search_implementation_1_1_i_search_client.html" title="Provides all necessary functions to implement a document-based search engine." alt="SemanticSearchImplementation.ISearchClient" shape="rect" coords="0,0,339,24"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa2ed113cba7590aff4b9d6d1682c6e49"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#aa2ed113cba7590aff4b9d6d1682c6e49">ElasticsearchSearchClient</a> (string server=&quot;localhost&quot;, string port=&quot;9200&quot;)</td></tr>
<tr class="separator:aa2ed113cba7590aff4b9d6d1682c6e49"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad539e2885d813afc8484844c43e21659"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ad539e2885d813afc8484844c43e21659">ChangeIndex</a> (string index)</td></tr>
<tr class="memdesc:ad539e2885d813afc8484844c43e21659"><td class="mdescLeft">&#160;</td><td class="mdescRight">Updates the current index.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ad539e2885d813afc8484844c43e21659">More...</a><br /></td></tr>
<tr class="separator:ad539e2885d813afc8484844c43e21659"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd867ae8d2f8cb1d10768502462e7b82"><td class="memItemLeft" align="right" valign="top">async Task&lt; IDictionary&lt; string, string &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#acd867ae8d2f8cb1d10768502462e7b82">GetMappingAsync</a> ()</td></tr>
<tr class="memdesc:acd867ae8d2f8cb1d10768502462e7b82"><td class="mdescLeft">&#160;</td><td class="mdescRight">Queries the mappings of the current index.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#acd867ae8d2f8cb1d10768502462e7b82">More...</a><br /></td></tr>
<tr class="separator:acd867ae8d2f8cb1d10768502462e7b82"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada6b558939d7039a662a0c584c27c043"><td class="memItemLeft" align="right" valign="top">async Task&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ada6b558939d7039a662a0c584c27c043">CreateIndexAsync</a> (JObject content, string index)</td></tr>
<tr class="memdesc:ada6b558939d7039a662a0c584c27c043"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates an index with the given settings and mappings.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ada6b558939d7039a662a0c584c27c043">More...</a><br /></td></tr>
<tr class="separator:ada6b558939d7039a662a0c584c27c043"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a656bbfaef5d43411849ca697a13934b2"><td class="memItemLeft" align="right" valign="top">async Task&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a656bbfaef5d43411849ca697a13934b2">AddDocumentsAsync</a> (IEnumerable&lt; JObject &gt; documents)</td></tr>
<tr class="memdesc:a656bbfaef5d43411849ca697a13934b2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds the given documents as a bulk upload.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a656bbfaef5d43411849ca697a13934b2">More...</a><br /></td></tr>
<tr class="separator:a656bbfaef5d43411849ca697a13934b2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46a54adb57d6821229aa73d7918a0e97"><td class="memItemLeft" align="right" valign="top">async Task&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a46a54adb57d6821229aa73d7918a0e97">SwitchAliasAsync</a> (string from, string to)</td></tr>
<tr class="memdesc:a46a54adb57d6821229aa73d7918a0e97"><td class="mdescLeft">&#160;</td><td class="mdescRight">Changes the alias from the old to the new index.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a46a54adb57d6821229aa73d7918a0e97">More...</a><br /></td></tr>
<tr class="separator:a46a54adb57d6821229aa73d7918a0e97"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e0d80cc6faed74485063882c8b5eeb6"><td class="memItemLeft" align="right" valign="top">async Task&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a1e0d80cc6faed74485063882c8b5eeb6">DeleteIndexAsync</a> (string index)</td></tr>
<tr class="memdesc:a1e0d80cc6faed74485063882c8b5eeb6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deletes the given index.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a1e0d80cc6faed74485063882c8b5eeb6">More...</a><br /></td></tr>
<tr class="separator:a1e0d80cc6faed74485063882c8b5eeb6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a23a0989ca4df1ffe0ae35ce370ff05a4"><td class="memItemLeft" align="right" valign="top">async Task&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a23a0989ca4df1ffe0ae35ce370ff05a4">AddDocumentAsync</a> (string graphName, IDictionary&lt; string, JObject &gt; documents)</td></tr>
<tr class="memdesc:a23a0989ca4df1ffe0ae35ce370ff05a4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds/updates a new document and possibly changes existing documents.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a23a0989ca4df1ffe0ae35ce370ff05a4">More...</a><br /></td></tr>
<tr class="separator:a23a0989ca4df1ffe0ae35ce370ff05a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a306ac19c0f67d957b1067e528efd53c7"><td class="memItemLeft" align="right" valign="top">async Task&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a306ac19c0f67d957b1067e528efd53c7">DeleteDocumentAsync</a> (string graphName, IDictionary&lt; string, JObject &gt; documents)</td></tr>
<tr class="memdesc:a306ac19c0f67d957b1067e528efd53c7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deletes a document and possibly changes other existing documents.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a306ac19c0f67d957b1067e528efd53c7">More...</a><br /></td></tr>
<tr class="separator:a306ac19c0f67d957b1067e528efd53c7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa4b8db03c1a6f59fed8fc3a21c2b71d6"><td class="memItemLeft" align="right" valign="top">async Task&lt; IDictionary&lt; string, double &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#aa4b8db03c1a6f59fed8fc3a21c2b71d6">SearchAsync</a> (string query, IEnumerable&lt; string &gt; projects, bool advanced, int size, int from, string sorting)</td></tr>
<tr class="memdesc:aa4b8db03c1a6f59fed8fc3a21c2b71d6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Searches the index using the alias.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#aa4b8db03c1a6f59fed8fc3a21c2b71d6">More...</a><br /></td></tr>
<tr class="separator:aa4b8db03c1a6f59fed8fc3a21c2b71d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a3ba32ace0e0cab0a2b48900f0872a688"><td class="memItemLeft" align="right" valign="top">async Task&lt; string &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a3ba32ace0e0cab0a2b48900f0872a688">GetIdFromGraphNameAsync</a> (string graphName)</td></tr>
<tr class="memdesc:a3ba32ace0e0cab0a2b48900f0872a688"><td class="mdescLeft">&#160;</td><td class="mdescRight">Queries the document ID for a metadata graph.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a3ba32ace0e0cab0a2b48900f0872a688">More...</a><br /></td></tr>
<tr class="separator:a3ba32ace0e0cab0a2b48900f0872a688"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae57d4f935abe00dbadddbe2d707bf91f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ae57d4f935abe00dbadddbe2d707bf91f">HandleResponse</a> (HttpResponseMessage response)</td></tr>
<tr class="memdesc:ae57d4f935abe00dbadddbe2d707bf91f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Handles response of a HTTP request.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ae57d4f935abe00dbadddbe2d707bf91f">More...</a><br /></td></tr>
<tr class="separator:ae57d4f935abe00dbadddbe2d707bf91f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a675e7317c556764f3f1775eeca4e18e2"><td class="memItemLeft" align="right" valign="top">HttpContent&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a675e7317c556764f3f1775eeca4e18e2">CreateJsonContent</a> (JObject content)</td></tr>
<tr class="separator:a675e7317c556764f3f1775eeca4e18e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b47e8b1bbba0e389cdc3b93b4342723"><td class="memItemLeft" align="right" valign="top">HttpContent&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a3b47e8b1bbba0e389cdc3b93b4342723">CreateJsonContent</a> (string content)</td></tr>
<tr class="separator:a3b47e8b1bbba0e389cdc3b93b4342723"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8fb393242f74b84e83b499ec66e7311c"><td class="memItemLeft" align="right" valign="top">async Task&lt; List&lt; string &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a8fb393242f74b84e83b499ec66e7311c">AddOtherDocuments</a> (List&lt; string &gt; contentList, KeyValuePair&lt; string, JObject &gt; document)</td></tr>
<tr class="memdesc:a8fb393242f74b84e83b499ec66e7311c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates the content list for a bulk request with the given documents.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a8fb393242f74b84e83b499ec66e7311c">More...</a><br /></td></tr>
<tr class="separator:a8fb393242f74b84e83b499ec66e7311c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adaafcf06cdd3290e3fa1fb08edcace48"><td class="memItemLeft" align="right" valign="top">async Task&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#adaafcf06cdd3290e3fa1fb08edcace48">BulkRequestAsync</a> (IEnumerable&lt; string &gt; contentList)</td></tr>
<tr class="memdesc:adaafcf06cdd3290e3fa1fb08edcace48"><td class="mdescLeft">&#160;</td><td class="mdescRight">Executes a bulk request with the given list of content.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#adaafcf06cdd3290e3fa1fb08edcace48">More...</a><br /></td></tr>
<tr class="separator:adaafcf06cdd3290e3fa1fb08edcace48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a82703171ca5f50be94daaab1785db0c2"><td class="memItemLeft" align="right" valign="top">JProperty&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a82703171ca5f50be94daaab1785db0c2">CreateVisibilityFilter</a> (IEnumerable&lt; string &gt; projects)</td></tr>
<tr class="memdesc:a82703171ca5f50be94daaab1785db0c2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates the visibility filter for search to allow a user only to see public metadata or metadata of own projects.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a82703171ca5f50be94daaab1785db0c2">More...</a><br /></td></tr>
<tr class="separator:a82703171ca5f50be94daaab1785db0c2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a34342fb826b3e64cdfc48afa412e5b8e"><td class="memItemLeft" align="right" valign="top">async Task&lt; IDictionary&lt; string, double &gt; &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a34342fb826b3e64cdfc48afa412e5b8e">Search</a> (JObject content)</td></tr>
<tr class="memdesc:a34342fb826b3e64cdfc48afa412e5b8e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Runs the search and handles the response.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a34342fb826b3e64cdfc48afa412e5b8e">More...</a><br /></td></tr>
<tr class="separator:a34342fb826b3e64cdfc48afa412e5b8e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae9a5146cb7ee4dab269aad27785d3448"><td class="memItemLeft" align="right" valign="top">IDictionary&lt; string, double &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ae9a5146cb7ee4dab269aad27785d3448">GetSearchResults</a> (JObject results)</td></tr>
<tr class="memdesc:ae9a5146cb7ee4dab269aad27785d3448"><td class="mdescLeft">&#160;</td><td class="mdescRight">Filters the plain search results of a search request.  <a href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ae9a5146cb7ee4dab269aad27785d3448">More...</a><br /></td></tr>
<tr class="separator:ae9a5146cb7ee4dab269aad27785d3448"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a04f9cbcfae637773d3d973f5e00e7d33"><td class="memItemLeft" align="right" valign="top">readonly string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a04f9cbcfae637773d3d973f5e00e7d33">baseUrl</a></td></tr>
<tr class="separator:a04f9cbcfae637773d3d973f5e00e7d33"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a34f256039687648971cb1c716cbac4d3"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a34f256039687648971cb1c716cbac4d3">_index</a></td></tr>
<tr class="separator:a34f256039687648971cb1c716cbac4d3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-static-attribs"></a>
Static Private Attributes</h2></td></tr>
<tr class="memitem:a0605373e42aced573965aca80dbd56b4"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a0605373e42aced573965aca80dbd56b4">ALIASES</a> = &quot;_aliases&quot;</td></tr>
<tr class="separator:a0605373e42aced573965aca80dbd56b4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae499d432b760ccfc2b5a6ae6aaeab067"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ae499d432b760ccfc2b5a6ae6aaeab067">SEARCH</a> = &quot;_search&quot;</td></tr>
<tr class="separator:ae499d432b760ccfc2b5a6ae6aaeab067"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a59c7c6c46f21fd05ae1ccd725d0669f3"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a59c7c6c46f21fd05ae1ccd725d0669f3">MAPPING</a> = &quot;_mapping&quot;</td></tr>
<tr class="separator:a59c7c6c46f21fd05ae1ccd725d0669f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae48c70684d8e9045f6b61bfaaaa96073"><td class="memItemLeft" align="right" valign="top">const string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#ae48c70684d8e9045f6b61bfaaaa96073">BULK</a> = &quot;_bulk&quot;</td></tr>
<tr class="separator:ae48c70684d8e9045f6b61bfaaaa96073"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0401dbd6fe37c7bd3b3280f30ae6da69"><td class="memItemLeft" align="right" valign="top">static readonly HttpClient&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_semantic_search_implementation_1_1_elasticsearch_search_client.html#a0401dbd6fe37c7bd3b3280f30ae6da69">client</a> = new HttpClient()</td></tr>
<tr class="separator:a0401dbd6fe37c7bd3b3280f30ae6da69"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Implements necessary functions to use Elasticsearch as a search engine. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aa2ed113cba7590aff4b9d6d1682c6e49"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa2ed113cba7590aff4b9d6d1682c6e49">&#9670;&nbsp;</a></span>ElasticsearchSearchClient()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">SemanticSearchImplementation.ElasticsearchSearchClient.ElasticsearchSearchClient </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>server</em> = <code>&quot;localhost&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>port</em> = <code>&quot;9200&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a23a0989ca4df1ffe0ae35ce370ff05a4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a23a0989ca4df1ffe0ae35ce370ff05a4">&#9670;&nbsp;</a></span>AddDocumentAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task SemanticSearchImplementation.ElasticsearchSearchClient.AddDocumentAsync </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>graphName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">IDictionary&lt; string, JObject &gt;&#160;</td>
          <td class="paramname"><em>documents</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds/updates a new document and possibly changes existing documents. </p>
<p>Additional rules can influence the mapping of existing metadata graphs.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">graphName</td><td>ID of the metadata graph to be added/updated.</td></tr>
    <tr><td class="paramname">documents</td><td>A dictionary containing the ID of metadata graphs (key) and corresponding JSON objects (value).</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A task that represents the asynchronous save operation.</dd></dl>

<p>Implements <a class="el" href="interface_semantic_search_implementation_1_1_i_search_client.html#a1ff333af40c8164aa40b129e745a37cc">SemanticSearchImplementation.ISearchClient</a>.</p>

</div>
</div>
<a id="a656bbfaef5d43411849ca697a13934b2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a656bbfaef5d43411849ca697a13934b2">&#9670;&nbsp;</a></span>AddDocumentsAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task SemanticSearchImplementation.ElasticsearchSearchClient.AddDocumentsAsync </td>
          <td>(</td>
          <td class="paramtype">IEnumerable&lt; JObject &gt;&#160;</td>
          <td class="paramname"><em>documents</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Adds the given documents as a bulk upload. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">documents</td><td>An enumerator of all documents as JSON object.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A task that represents the asynchronous save operation.</dd></dl>

<p>Implements <a class="el" href="interface_semantic_search_implementation_1_1_i_search_client.html#aa8400c98add1356b9d594264cc1084ec">SemanticSearchImplementation.ISearchClient</a>.</p>

</div>
</div>
<a id="a8fb393242f74b84e83b499ec66e7311c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8fb393242f74b84e83b499ec66e7311c">&#9670;&nbsp;</a></span>AddOtherDocuments()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task&lt;List&lt;string&gt; &gt; SemanticSearchImplementation.ElasticsearchSearchClient.AddOtherDocuments </td>
          <td>(</td>
          <td class="paramtype">List&lt; string &gt;&#160;</td>
          <td class="paramname"><em>contentList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">KeyValuePair&lt; string, JObject &gt;&#160;</td>
          <td class="paramname"><em>document</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Creates the content list for a bulk request with the given documents. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">contentList</td><td>A list containing the content for the bulk request.</td></tr>
    <tr><td class="paramname">document</td><td>IDs of metadata graphs (key) and their correcsponding content as JSON object (value).</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The task result contains the created content list for the bulk request.</dd></dl>

</div>
</div>
<a id="adaafcf06cdd3290e3fa1fb08edcace48"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adaafcf06cdd3290e3fa1fb08edcace48">&#9670;&nbsp;</a></span>BulkRequestAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task SemanticSearchImplementation.ElasticsearchSearchClient.BulkRequestAsync </td>
          <td>(</td>
          <td class="paramtype">IEnumerable&lt; string &gt;&#160;</td>
          <td class="paramname"><em>contentList</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Executes a bulk request with the given list of content. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">contentList</td><td>An enumerator of content rows for the bulk request.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A task that represents the asynchronous save operation.</dd></dl>

</div>
</div>
<a id="ad539e2885d813afc8484844c43e21659"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad539e2885d813afc8484844c43e21659">&#9670;&nbsp;</a></span>ChangeIndex()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void SemanticSearchImplementation.ElasticsearchSearchClient.ChangeIndex </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Updates the current index. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">index</td><td>Name of new current index.</td></tr>
  </table>
  </dd>
</dl>

<p>Implements <a class="el" href="interface_semantic_search_implementation_1_1_i_search_client.html#a5f3281adfa42ef1587f0ff32454aef26">SemanticSearchImplementation.ISearchClient</a>.</p>

</div>
</div>
<a id="ada6b558939d7039a662a0c584c27c043"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada6b558939d7039a662a0c584c27c043">&#9670;&nbsp;</a></span>CreateIndexAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task SemanticSearchImplementation.ElasticsearchSearchClient.CreateIndexAsync </td>
          <td>(</td>
          <td class="paramtype">JObject&#160;</td>
          <td class="paramname"><em>content</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>index</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Creates an index with the given settings and mappings. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">content</td><td>JSON object containing the settings and mappings.</td></tr>
    <tr><td class="paramname">index</td><td>The index name.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A task that represents the asynchronous save operation.</dd></dl>

<p>Implements <a class="el" href="interface_semantic_search_implementation_1_1_i_search_client.html#a9ab1b757bf2df8b7324dd94cfebb3077">SemanticSearchImplementation.ISearchClient</a>.</p>

</div>
</div>
<a id="a675e7317c556764f3f1775eeca4e18e2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a675e7317c556764f3f1775eeca4e18e2">&#9670;&nbsp;</a></span>CreateJsonContent() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">HttpContent SemanticSearchImplementation.ElasticsearchSearchClient.CreateJsonContent </td>
          <td>(</td>
          <td class="paramtype">JObject&#160;</td>
          <td class="paramname"><em>content</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a3b47e8b1bbba0e389cdc3b93b4342723"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3b47e8b1bbba0e389cdc3b93b4342723">&#9670;&nbsp;</a></span>CreateJsonContent() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">HttpContent SemanticSearchImplementation.ElasticsearchSearchClient.CreateJsonContent </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>content</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a82703171ca5f50be94daaab1785db0c2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a82703171ca5f50be94daaab1785db0c2">&#9670;&nbsp;</a></span>CreateVisibilityFilter()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">JProperty SemanticSearchImplementation.ElasticsearchSearchClient.CreateVisibilityFilter </td>
          <td>(</td>
          <td class="paramtype">IEnumerable&lt; string &gt;&#160;</td>
          <td class="paramname"><em>projects</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Creates the visibility filter for search to allow a user only to see public metadata or metadata of own projects. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">projects</td><td>An enumerator containing the projects which are allowed.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A JProperty containing the specified visibility filter.</dd></dl>

</div>
</div>
<a id="a306ac19c0f67d957b1067e528efd53c7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a306ac19c0f67d957b1067e528efd53c7">&#9670;&nbsp;</a></span>DeleteDocumentAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task SemanticSearchImplementation.ElasticsearchSearchClient.DeleteDocumentAsync </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>graphName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">IDictionary&lt; string, JObject &gt;&#160;</td>
          <td class="paramname"><em>documents</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Deletes a document and possibly changes other existing documents. </p>
<p>Additional rules can influence the mapping of existing metadata graphs.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">graphName</td><td>ID of the metadata graph to be deleted.</td></tr>
    <tr><td class="paramname">documents</td><td>A dictionary containing the ID of metadata graphs (key) and corresponding JSON objects (value).</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A task that represents the asynchronous delete operation.</dd></dl>

<p>Implements <a class="el" href="interface_semantic_search_implementation_1_1_i_search_client.html#a1cb5a1be1f418a82548c707f35a565af">SemanticSearchImplementation.ISearchClient</a>.</p>

</div>
</div>
<a id="a1e0d80cc6faed74485063882c8b5eeb6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1e0d80cc6faed74485063882c8b5eeb6">&#9670;&nbsp;</a></span>DeleteIndexAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task SemanticSearchImplementation.ElasticsearchSearchClient.DeleteIndexAsync </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Deletes the given index. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">index</td><td>Name of the index.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A task that represents the asynchronous delete operation.</dd></dl>

<p>Implements <a class="el" href="interface_semantic_search_implementation_1_1_i_search_client.html#acb7deea3df7b5e8a69eb6cedb7a43ab3">SemanticSearchImplementation.ISearchClient</a>.</p>

</div>
</div>
<a id="a3ba32ace0e0cab0a2b48900f0872a688"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3ba32ace0e0cab0a2b48900f0872a688">&#9670;&nbsp;</a></span>GetIdFromGraphNameAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task&lt;string&gt; SemanticSearchImplementation.ElasticsearchSearchClient.GetIdFromGraphNameAsync </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>graphName</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Queries the document ID for a metadata graph. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">graphName</td><td>ID of the metadata graph.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>ID of the Elasticsearch document.</dd></dl>

</div>
</div>
<a id="acd867ae8d2f8cb1d10768502462e7b82"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acd867ae8d2f8cb1d10768502462e7b82">&#9670;&nbsp;</a></span>GetMappingAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task&lt;IDictionary&lt;string, string&gt; &gt; SemanticSearchImplementation.ElasticsearchSearchClient.GetMappingAsync </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Queries the mappings of the current index. </p>
<dl class="section return"><dt>Returns</dt><dd>A dictionary containing the fields and corresponding types.</dd></dl>

<p>Implements <a class="el" href="interface_semantic_search_implementation_1_1_i_search_client.html#a919066ae905397687167580e2d7ff227">SemanticSearchImplementation.ISearchClient</a>.</p>

</div>
</div>
<a id="ae9a5146cb7ee4dab269aad27785d3448"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae9a5146cb7ee4dab269aad27785d3448">&#9670;&nbsp;</a></span>GetSearchResults()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">IDictionary&lt;string, double&gt; SemanticSearchImplementation.ElasticsearchSearchClient.GetSearchResults </td>
          <td>(</td>
          <td class="paramtype">JObject&#160;</td>
          <td class="paramname"><em>results</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Filters the plain search results of a search request. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">results</td><td>Plain JSON result of a search request.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A dictionary containing the ID of the metadata graphs (key) and the corresponding rankings (value),</dd></dl>

</div>
</div>
<a id="ae57d4f935abe00dbadddbe2d707bf91f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae57d4f935abe00dbadddbe2d707bf91f">&#9670;&nbsp;</a></span>HandleResponse()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void SemanticSearchImplementation.ElasticsearchSearchClient.HandleResponse </td>
          <td>(</td>
          <td class="paramtype">HttpResponseMessage&#160;</td>
          <td class="paramname"><em>response</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Handles response of a HTTP request. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">response</td><td>The response of a HTTP request.</td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a34342fb826b3e64cdfc48afa412e5b8e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a34342fb826b3e64cdfc48afa412e5b8e">&#9670;&nbsp;</a></span>Search()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task&lt;IDictionary&lt;string, double&gt; &gt; SemanticSearchImplementation.ElasticsearchSearchClient.Search </td>
          <td>(</td>
          <td class="paramtype">JObject&#160;</td>
          <td class="paramname"><em>content</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Runs the search and handles the response. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">content</td><td>A JSON object containing the body of the search request.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The task result contains a dictionary containing the IDs of the found metadata graphs (key) and the corresponding ranking (value).</dd></dl>

</div>
</div>
<a id="aa4b8db03c1a6f59fed8fc3a21c2b71d6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa4b8db03c1a6f59fed8fc3a21c2b71d6">&#9670;&nbsp;</a></span>SearchAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task&lt;IDictionary&lt;string, double&gt; &gt; SemanticSearchImplementation.ElasticsearchSearchClient.SearchAsync </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>query</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">IEnumerable&lt; string &gt;&#160;</td>
          <td class="paramname"><em>projects</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>advanced</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>sorting</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Searches the index using the alias. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">query</td><td>The search query of the user.</td></tr>
    <tr><td class="paramname">projects</td><td>List of allowed projects (of a user).</td></tr>
    <tr><td class="paramname">advanced</td><td>Flag to specify simple or advanced search syntax.</td></tr>
    <tr><td class="paramname">size</td><td>Number of results.</td></tr>
    <tr><td class="paramname">from</td><td>Position from which the results should be returned.</td></tr>
    <tr><td class="paramname">sorting</td><td>Sorting of the results  (see <a href="https://www.elastic.co/guide/en/elasticsearch/reference/current/sort-search-results.html">https://www.elastic.co/guide/en/elasticsearch/reference/current/sort-search-results.html</a>). </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The task result contains a dictionary containing the IDs of the found metadata graphs (key) and the corresponding ranking (value).</dd></dl>

<p>Implements <a class="el" href="interface_semantic_search_implementation_1_1_i_search_client.html#a4941aadcb081b3debbf4b3a57986882e">SemanticSearchImplementation.ISearchClient</a>.</p>

</div>
</div>
<a id="a46a54adb57d6821229aa73d7918a0e97"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a46a54adb57d6821229aa73d7918a0e97">&#9670;&nbsp;</a></span>SwitchAliasAsync()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">async Task SemanticSearchImplementation.ElasticsearchSearchClient.SwitchAliasAsync </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>to</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Changes the alias from the old to the new index. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">from</td><td>Name of old index.</td></tr>
    <tr><td class="paramname">to</td><td>Name of new index.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd></dd></dl>

<p>Implements <a class="el" href="interface_semantic_search_implementation_1_1_i_search_client.html#a1ad1eab5dedb94a615d1c8608dc7052f">SemanticSearchImplementation.ISearchClient</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a34f256039687648971cb1c716cbac4d3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a34f256039687648971cb1c716cbac4d3">&#9670;&nbsp;</a></span>_index</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">string SemanticSearchImplementation.ElasticsearchSearchClient._index</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a0605373e42aced573965aca80dbd56b4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0605373e42aced573965aca80dbd56b4">&#9670;&nbsp;</a></span>ALIASES</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const string SemanticSearchImplementation.ElasticsearchSearchClient.ALIASES = &quot;_aliases&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a04f9cbcfae637773d3d973f5e00e7d33"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a04f9cbcfae637773d3d973f5e00e7d33">&#9670;&nbsp;</a></span>baseUrl</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">readonly string SemanticSearchImplementation.ElasticsearchSearchClient.baseUrl</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ae48c70684d8e9045f6b61bfaaaa96073"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae48c70684d8e9045f6b61bfaaaa96073">&#9670;&nbsp;</a></span>BULK</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const string SemanticSearchImplementation.ElasticsearchSearchClient.BULK = &quot;_bulk&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a0401dbd6fe37c7bd3b3280f30ae6da69"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0401dbd6fe37c7bd3b3280f30ae6da69">&#9670;&nbsp;</a></span>client</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">readonly HttpClient SemanticSearchImplementation.ElasticsearchSearchClient.client = new HttpClient()</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a59c7c6c46f21fd05ae1ccd725d0669f3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a59c7c6c46f21fd05ae1ccd725d0669f3">&#9670;&nbsp;</a></span>MAPPING</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const string SemanticSearchImplementation.ElasticsearchSearchClient.MAPPING = &quot;_mapping&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ae499d432b760ccfc2b5a6ae6aaeab067"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae499d432b760ccfc2b5a6ae6aaeab067">&#9670;&nbsp;</a></span>SEARCH</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const string SemanticSearchImplementation.ElasticsearchSearchClient.SEARCH = &quot;_search&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="_elasticsearch_search_client_8cs.html">ElasticsearchSearchClient.cs</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="http://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.8.20
</small></address>
</body>
</html>
